/*
### Written by Torsten Moeller
### sometime in March 1998
### let me know, if you find any errors (moeller@cis.ohio-state.edu)
###
### March 2003 - modified to remove coeff part
### The convention is that all filters are zero outside [0..N]
### The filters thmselves do not report their size. They are marked as
### comments in this file.
*/

#ifndef _TMFILTERS_RAW_H_
#define _TMFILTERS_RAW_H_

float d0_cn_1ef(float a, float t); // Size: 2
float d0_cn_2ef(float a, float t); // Size: 2
float d0_cn_3ef(float a, float t); // Size: 4
float d0_cn_4ef(float a, float t); // Size: 4
float d0_c0_1ef(float a, float t); // Size: 2                accuracy
float d0_c0_2ef(float a, float t); // Size: 2    smoothness |  1EF | 2EF | 3EF | 4EF
float d0_c0_3ef(float a, float t); // Size: 4    -----------+------+-----+-----+-----
float d0_c0_4ef(float a, float t); // Size: 4       C^{-1}  |   2  |  2  |  4  |  4
float d0_c1_1ef(float a, float t); // Size: 2       C^0     |   2  |  2  |  4  |  4
float d0_c1_2ef(float a, float t); // Size: 4       C^1     |   2  |  4  |  4  |  6
float d0_c1_3ef(float a, float t); // Size: 4       C^2     |   2  |  4  |  4  |  6
float d0_c1_4ef(float a, float t); // Size: 6       C^3     |   2  |  4  |  4  |  6
float d0_c2_1ef(float a, float t); // Size: 2
float d0_c2_2ef(float a, float t); // Size: 4
float d0_c2_3ef(float a, float t); // Size: 4
float d0_c2_4ef(float a, float t); // Size: 6
float d0_c3_1ef(float a, float t); // Size: 2
float d0_c3_2ef(float a, float t); // Size: 4
float d0_c3_3ef(float a, float t); // Size: 4
float d0_c3_4ef(float a, float t); // Size: 6

float d1_cn_1ef(float a, float t); // Size: 2
float d1_cn_2ef(float a, float t); // Size: 4
float d1_cn_3ef(float a, float t); // Size: 4
float d1_cn_4ef(float a, float t); // Size: 6
float d1_c0_1ef(float a, float t); // Size: 4                accuracy
float d1_c0_2ef(float a, float t); // Size: 4    smoothness |  1EF | 2EF | 3EF | 4EF
float d1_c0_3ef(float a, float t); // Size: 6    -----------+------+-----+-----+-----
float d1_c0_4ef(float a, float t); // Size: 6       C^{-1}  |   2  |  4  |  4  |  6
float d1_c1_1ef(float a, float t); // Size: 4       C^0     |   4  |  4  |  6  |  6
float d1_c1_2ef(float a, float t); // Size: 4       C^1     |   4  |  4  |  6  |  6
float d1_c1_3ef(float a, float t); // Size: 6       C^2     |   4  |  4  |  6  |  6
float d1_c1_4ef(float a, float t); // Size: 6       C^3     |   4  |  4  |  6  |  6
float d1_c2_1ef(float a, float t); // Size: 4
float d1_c2_2ef(float a, float t); // Size: 4
float d1_c2_3ef(float a, float t); // Size: 6
float d1_c2_4ef(float a, float t); // Size: 6
float d1_c3_1ef(float a, float t); // Size: 4
float d1_c3_2ef(float a, float t); // Size: 4
float d1_c3_3ef(float a, float t); // Size: 6
float d1_c3_4ef(float a, float t); // Size: 6

float d2_cn_1ef(float a, float t); // Size: 
float d2_cn_2ef(float a, float t); // Size: 
float d2_cn_3ef(float a, float t); // Size: 
float d2_cn_4ef(float a, float t); // Size: 
float d2_c0_1ef(float a, float t); // Size:                 accuracy
float d2_c0_2ef(float a, float t); // Size:     smoothness |  1EF | 2EF | 3EF | 4EF
float d2_c0_3ef(float a, float t); // Size:     -----------+------+-----+-----+-----
float d2_c0_4ef(float a, float t); // Size:        C^{-1}  |   4  |  4  |  6  |  6
float d2_c1_1ef(float a, float t); // Size:        C^0     |   4  |  4  |  6  |  6
float d2_c1_2ef(float a, float t); // Size:        C^1     |   4  |  6  |  6  |  8
float d2_c1_3ef(float a, float t); // Size:        C^2     |   4  |  6  |  6  |  8
float d2_c1_4ef(float a, float t); // Size:        C^3     |   4  |  6  |  6  |  8
float d2_c2_1ef(float a, float t); // Size: 
float d2_c2_2ef(float a, float t); // Size: 
float d2_c2_3ef(float a, float t); // Size: 
float d2_c2_4ef(float a, float t); // Size: 
float d2_c3_1ef(float a, float t); // Size: 
float d2_c3_2ef(float a, float t); // Size: 
float d2_c3_3ef(float a, float t); // Size: 
float d2_c3_4ef(float a, float t); // Size: 

#endif
